{-# LANGUAGE DataKinds #-}

module Projects.GNYData2020Chi3 where

import           SDPB.Math.Linear.Literal                    (toV) 
import           Hyperion.Bootstrap.AffineTransform          (AffineTransform (..))



-----------
-- N = 2 --
-----------
gny2AffineNmax6 :: AffineTransform 2 Rational
gny2AffineNmax6 = AffineTransform
  { affineShift  = toV (1.06,0.6)
  , affineLinear = toV ( toV (0.015,0)
                       , toV (0, 0.1)
                       )
  }

gny2Affine3dWindow :: AffineTransform 3 Rational
gny2Affine3dWindow = AffineTransform
  { affineShift  = toV (1.06, 0.6, 1.3)
  , affineLinear = toV ( toV (0.015 , 0 , 0)
                       , toV (0, 0.1, 0 )
                       , toV (0, 0, 0.7)
                       )
  }



gny2Affine3dNmax6 :: AffineTransform 3 Rational 
gny2Affine3dNmax6 = AffineTransform 
  { affineShift  = toV (1.07823, 0.644172, 1.09682) 
  , affineLinear = toV ( toV (0.000893395, 0.0381622, 0.733777) 
                       , toV (-0.00615201, -0.0532538, 0.00277711) 
                       , toV (-0.0107165, 0.00123533, -0.0000511991) 
                       ) 
  } 
 
gny2Affine3dNmax8 :: AffineTransform 3 Rational  
gny2Affine3dNmax8 = AffineTransform  
  { affineShift  = toV (1.07085, 0.602063, 1.09909)
  , affineLinear = toV ( toV (0.00015672, 0.0378294, 0.672118)
                       , toV (0.00495225, 0.0313196, -0.00176394)
                       , toV (-0.00801564, 0.00126353, -0.0000692475)
                       )  
  }  

gny2Affine3dNmax10 :: AffineTransform 3 Rational   
gny2Affine3dNmax10 = AffineTransform   
  { affineShift  = toV (1.07042, 0.627361, 1.50022)
  , affineLinear = toV ( toV (0.000598736, 0.0199621, 0.256242)
                       , toV (0.00108854, 0.0175067, -0.00136637)
                       , toV (-0.00369334, 0.000228928, -0.00000920433)
                       )   
  }   

gny2Affine3dNmax12 :: AffineTransform 3 Rational    
gny2Affine3dNmax12 = AffineTransform    
  { affineShift  = toV (1.07042, 0.627361, 1.50022) 
  , affineLinear = toV ( toV (0.000598736, 0.0199621, 0.256242) 
                       , toV (0.00108854, 0.0175067, -0.00136637) 
                       , toV (-0.00369334, 0.000228928, -0.00000920433) 
                       )    
  }    
 

-- nmax = 6 
n2nmax6DualPoints :: [(Rational, Rational, Rational)]   
n2nmax6DualPoints =       
  [(1.06515, 0.624321, 1.14565), (1.06517, 0.627005, 1.33401), (1.07337, 0.626162, 1.33128), (1.07124, 0.651697, 1.74884), (1.07065, 0.635842, 1.6256), (1.06675, 0.620815, 1.43396), (1.07389, 0.638964, 1.54675), (1.07024, 0.647999, 1.73634), (1.07325, 0.648641, 1.36395), (1.06606, 0.640047, 1.60339), (1.06832, 0.660286, 1.66299), (1.07252, 0.632353, 1.48427), (1.06708, 0.641805, 1.38912), (1.06597, 0.637951, 1.44722), (1.074, 0.62, 1.4), (1.066, 0.66, 1.76667), (1.07329, 0.64098, 1.30119), (1.07315, 0.624876, 1.29825), (1.06853, 0.653466, 1.54864), (1.06654, 0.642261, 1.49607), (1.07338, 0.626984, 1.36352), (1.07192, 0.64782, 1.70556), (1.07293, 0.62175, 1.34117), (1.065, 0.63, 1.83333), (1.06412, 0.613051, 1.2928), (1.06487, 0.621605, 1.24406), (1.07155, 0.64882, 1.35285), (1.0718, 0.644446, 1.69234), (1.0691, 0.631981, 1.21668), (1.07062, 0.648174, 1.38036), (1.06462, 0.609348, 1.24096), (1.07216, 0.644247, 1.67177), (1.06412, 0.602053, 1.13302), (1.07195, 0.654567, 1.44705), (1.07386, 0.64383, 1.47397), (1.06802, 0.628952, 1.56561), (1.06552, 0.631857, 1.37923), (1.07186, 0.619968, 1.31122), (1.0713, 0.622431, 1.4), (1.07105, 0.614108, 1.21455), (1.06911, 0.633328, 1.19229), (1.07192, 0.646311, 1.3378), (1.06907, 0.625534, 1.13464), (1.07661, 0.656241, 1.32465), (1.06902, 0.610807, 1.1778), (1.06644, 0.622548, 1.18766), (1.07393, 0.625939, 1.54105)] 
n2nmax6PrimalPoints :: [(Rational, Rational, Rational)]  
n2nmax6PrimalPoints =  
  [(1.06611, 0.635062, 1.50262), (1.07336, 0.633157, 1.37589), (1.0657, 0.616317, 1.15685), (1.072, 0.625, 1.1), (1.06627, 0.618071, 1.16944), (1.06612, 0.634485, 1.45553), (1.06817, 0.619406, 1.14646), (1.07096, 0.622142, 1.23476), (1.06514, 0.618236, 1.32227), (1.068, 0.64, 1.4), (1.07074, 0.642175, 1.31846), (1.06756, 0.638792, 1.65314), (1.06724, 0.637833, 1.48112), (1.07181, 0.629064, 1.14174), (1.06697, 0.610781, 1.14756), (1.06463, 0.616552, 1.33888), (1.06805, 0.655173, 1.71583), (1.07039, 0.627695, 1.46409), (1.07162, 0.619041, 1.09813), (1.07062, 0.642032, 1.36608), (1.06723, 0.649996, 1.69967), (1.07037, 0.63903, 1.65543), (1.06997, 0.629484, 1.22214), (1.07101, 0.646337, 1.70966), (1.069, 0.635, 1.3), (1.06756, 0.621296, 1.35813), (1.07087, 0.664464, 1.73763), (1.06667, 0.61646, 1.1332), (1.07, 0.645, 1.7), (1.06832, 0.655945, 1.69211), (1.0685, 0.643216, 1.69718), (1.07368, 0.64432, 1.51237), (1.0664, 0.632684, 1.39972), (1.06972, 0.663418, 1.76988), (1.06833, 0.65125, 1.725), (1.06689, 0.619445, 1.22956), (1.06514, 0.613279, 1.23457), (1.06864, 0.624246, 1.42713), (1.07072, 0.627238, 1.12769), (1.07217, 0.621127, 1.12305), (1.07038, 0.622973, 1.25851), (1.07, 0.63, 1.26667), (1.069, 0.615, 1.1), (1.06988, 0.618859, 1.25603), (1.06613, 0.631721, 1.39052), (1.07176, 0.654692, 1.46433), (1.0672, 0.618746, 1.14298), (1.07097, 0.661169, 1.5811), (1.06995, 0.641325, 1.66739), (1.072, 0.63, 1.4)]



-- nmax = 8
n2nmax8DualPoints :: [(Rational, Rational, Rational)]   
n2nmax8DualPoints =   
  [(1.07176, 0.654692, 1.46433), (1.07097, 0.661169, 1.5811), (1.06514, 0.613279, 1.23457), (1.06995, 0.641325, 1.66739), (1.0664, 0.632684, 1.39972), (1.06756, 0.621296, 1.35813), (1.072, 0.63, 1.4), (1.06463, 0.616552, 1.33888), (1.07, 0.63, 1.26667), (1.0657, 0.616317, 1.15685), (1.07087, 0.664464, 1.73763), (1.07, 0.645, 1.7), (1.07038, 0.622973, 1.25851), (1.06514, 0.618236, 1.32227), (1.06724, 0.637833, 1.48112), (1.06627, 0.618071, 1.16944), (1.06723, 0.649996, 1.69967), (1.07039, 0.627695, 1.46409), (1.06613, 0.631721, 1.39052), (1.06697, 0.610781, 1.14756), (1.069, 0.615, 1.1), (1.06997, 0.629484, 1.22214), (1.069, 0.635, 1.3), (1.06612, 0.634485, 1.45553), (1.06689, 0.619445, 1.22956), (1.07072, 0.627238, 1.12769), (1.06611, 0.635062, 1.50262), (1.07074, 0.642175, 1.31846), (1.07368, 0.64432, 1.51237), (1.07336, 0.633157, 1.37589), (1.07037, 0.63903, 1.65543), (1.06988, 0.618859, 1.25603), (1.06864, 0.624246, 1.42713), (1.06805, 0.655173, 1.71583), (1.07181, 0.629064, 1.14174), (1.07162, 0.619041, 1.09813), (1.06972, 0.663418, 1.76988), (1.07101, 0.646337, 1.70966), (1.0685, 0.643216, 1.69718), (1.07217, 0.621127, 1.12305), (1.06756, 0.638792, 1.65314), (1.072, 0.625, 1.1), (1.06817, 0.619406, 1.14646), (1.06667, 0.61646, 1.1332), (1.07096, 0.622142, 1.23476), (1.07124, 0.651697, 1.74884), (1.066, 0.66, 1.76667)] 
n2nmax8PrimalPoints :: [(Rational, Rational, Rational)]   
n2nmax8PrimalPoints =   
  [(1.06833, 0.65125, 1.725), (1.06838, 0.654155, 1.69413), (1.06916, 0.641246, 1.59864), (1.06916, 0.647701, 1.69413), (1.06838, 0.654155, 1.74188), (1.06916, 0.647701, 1.59864), (1.06916, 0.641246, 1.64638), (1.06993, 0.647701, 1.64638), (1.06993, 0.641246, 1.59864)] 


-- nmax = 10
n2nmax10DualPoints :: [(Rational, Rational, Rational)]
n2nmax10DualPoints = 
  [(53419/50000, 130831/200000, 169413/100000), (26729/25000, 320623/500000, 82319/50000), (106609811239/99532800000, 2574142736473/3981312000000, 108446401307/ 66355200000), (1973210747/1843200000, 143446458481/221184000000, 35049290311/22118400000), (20520731/19200000, 1097037517/1728000000, 271824379/172800000), (41061803/38400000, 505969033/768000000, 132764237/76800000), (26647170143/24883200000, 43160969069/ 66355200000, 82204198261/49766400000), (82169/76800, 10302611/ 16000000, 2679937/1600000), (6120518794319/5733089280000, 416246307260317/644972544000000, 214207288186187/ 128994508800000), (1972808317/1843200000, 72087344029/110592000000, 17849549891/11059200000), (9084149107063/8493465600000, 164675443945727/254803968000000, 7929600865057/ 5096079360000), (10024/9375, 768577/1200000, 99151/60000), (2564461/ 2400000, 931589/1440000, 5681753/3600000), (504113985157/ 471859200000, 108113113178107/169869312000000, 27110048694847/ 16986931200000), (13214513489617783/12383472844800000, 178424700494180353/278628139008000000, 3594889991233583/ 2229025112064000), (554638517/518400000, 282114049/432000000, 297537827/172800000), (5921004269/5529600000, 141734187133/ 221184000000, 17672390933/11059200000), (2664236327/2488320000, 21659214697/33177600000, 42271287473/24883200000), (2549652081149/ 2388787200000, 34487443678391/53747712000000, 17241889047733/ 10749542400000), (94033502331699859/88060251340800000, 1286194011255977557/1981355655168000000, 677670921845216339/ 396271131033600000), (15389261/14400000, 1118628181/1728000000, 53856911/34560000), (369563801/345600000, 747645341/1152000000, 44254341/25600000)] 
n2nmax10PrimalPoints :: [(Rational, Rational, Rational)]
n2nmax10PrimalPoints =
  [(1.06833, 0.65125, 1.725), (1.06916, 0.641246, 1.59864), (1.06916, 0.647701, 1.69413), (1.06838, 0.654155, 1.74188), (1.06916, 0.647701, 1.59864), (1.06993, 0.647701, 1.64638), (1.06993, 0.641246, 1.59864)]


n2nmax10DualPoints2 :: [(Rational, Rational, Rational)]
n2nmax10DualPoints2 = 
  [(13214513489617783/12383472844800000, 178424700494180353/278628139008000000, 3594889991233583/2229025112064000), (15389261/14400000, 1118628181/1728000000, 53856911/34560000), (1972808317/1843200000, 72087344029/110592000000, 17849549891/11059200000), (1973210747/1843200000, 143446458481/221184000000, 35049290311/22118400000), (20520731/19200000, 1097037517/1728000000, 271824379/172800000), (2549652081149/2388787200000, 34487443678391/53747712000000, 17241889047733/10749542400000), (2564461/2400000, 931589/1440000, 5681753/3600000), (2664236327/2488320000, 21659214697/33177600000, 42271287473/24883200000), (26647170143/24883200000, 43160969069/66355200000, 82204198261/49766400000), (26729/25000, 320623/500000, 82319/50000), (369563801/345600000, 747645341/1152000000, 44254341/25600000), (41061803/38400000, 505969033/768000000, 132764237/76800000), (504113985157/471859200000, 108113113178107/169869312000000, 27110048694847/16986931200000), (53419/50000, 130831/200000, 169413/100000), (554638517/518400000, 282114049/432000000, 297537827/172800000), (5921004269/5529600000, 141734187133/221184000000, 17672390933/11059200000), (6120518794319/5733089280000, 416246307260317/644972544000000, 214207288186187/128994508800000), (82169/76800, 10302611/16000000, 2679937/1600000), (9084149107063/8493465600000, 164675443945727/254803968000000, 7929600865057/5096079360000), (94033502331699859/88060251340800000, 1286194011255977557/1981355655168000000, 677670921845216339/396271131033600000), (10024/9375, 768577/1200000, 99151/60000), (106609811239/99532800000, 2574142736473/3981312000000, 108446401307/66355200000), (922813896521/864000000000, 372160514857/576000000000, 2781353744393/1600000000000), (267624087/250000000, 490214009/750000000, 1049366883433/600000000000), (153870041339/144000000000, 378287287013/576000000000, 12484268913929/7200000000000), (352660513489068345571/330225942528000000000, 967574610307732604801/1486016741376000000000, 64695379170534329318891/37150418534400000000000), (123205723/ 115200000, 6636080749/10368000000, 1670608699/1036800000), (142061583073/132710400000, 10295501039077/15925248000000, 1300127850277/796262400000), (36317462137207/33973862400000, 659502730981631/1019215872000000, 160304420585381/101921587200000), (68181896738596231/63700992000000000, 9716816702990971/15288238080000000, 56341575038480017/38220595200000000), (492836773/460800000, 1482322313/2304000000, 382404787/230400000), (87258759590113/81537269760000, 2649695214019199/4076863488000000, 662206147345957/407686348800000), (1277794672909/1194393600000, 5201209280317/7962624000000, 803440107613/477757440000), (218013550575169/203843174400000, 3964385117533433/6115295232000000, 970816476553091/611529523200000), (6650076962713/6220800000000, 5466923407769/8294400000000, 180531897784127/103680000000000), (2116759163754423634147/1981355655168000000000, 5848058513948943058817/8916100448256000000000, 388448373009496194579947/ 222902511206400000000000), (115009911518880941/ 107495424000000000, 3167499683855497867/4953389137920000000, 18933306466538692879/12383472844800000000), (141113761916215601927/132090377011200000000, 385399428266589764473/594406696550400000000, 25597978474923756808903/14860167413760000000000), (71026319539/ 66355200000, 191711589131/294912000000, 221431437077/132710400000), (153112499822577733/ 143327232000000000, 26442877474989975683/41278242816000000000, 786304842925092279139/515978035200000000000), (1744555220492923/ 1630745395200000, 31746485075701603/48922361856000000, 7880457365287729/4892236185600000), (12715513516933148690659/11888133931008000000000, 34990082209453029328769/53496602689536000000000, 2334360401698785339276779/ 1337415067238400000000000), (2450959231851353947/ 2293235712000000000, 6741156044099154377/10319560704000000000, 426304317012736625507/257989017600000000000), (147077074765793/137594142720000, 632731173184379347/990677827584000000, 6344815418106871/3962711310336000), (436286466631763/407686348800000, 7894591899160891/12230590464000000, 1953547279870009/1223059046400000), (12477976748167/11664000000000, 81554380788283/124416000000000, 2019967869350323/1166400000000000), (99772067255083/93312000000000, 5110641917477/7776000000000, 1346879246716303/777600000000000), (132271834195559670013/123834728448000000000, 5795818191009985958603/8916100448256000000000, 183663051356411464640899/ 111451255603200000000000), (568121113753/530841600000, 40960683945229/63700992000000, 5152613438221/3185049600000), (152375223335989950823871/ 142657607172096000000000, 414039630954527129592541/641959232274432000000000, 27312010369333488062136631/16048980806860800000000000), (2823305748241528242019/2641807540224000000000, 7652698074587670106649/11888133931008000000000, 501908344488773198517659/ 297203348275200000000000), (1277837159579/1194393600000, 10281249951457/15925248000000, 799810803713/477757440000), (5584297896744571/5218385264640000, 101411534552054371/156551557939200000, 127456534654546421/78275778969600000), (58781247750694902943/ 55037657088000000000, 1245418038307291789963/1981355655168000000000, 35555298217387277320679/24766945689600000000000), (209368558898311/195689447424000, 10609427692744831/16307453952000000, 8071338042351727/4892236185600000), (11042764157601202043/10319560704000000000, 19014438743708259391/29720334827520000000, 115940303900336041387/74300837068800000000), (2942534273334757/ 2751882854400000, 317661241040547017/495338913792000000, 16159487968153237/9906778275840000), (609796482224604986777969/570630428688384000000000, 1690363256904235063085851/2567836929097728000000000, 112123394799847909247040841/ 64195923227443200000000000), (2117468213283637694467/ 1981355655168000000000, 5797823356448158914671/8916100448256000000000, 386809360681073388980711/222902511206400000000000), (14717829077460383237/13759414272000000000, 3191910661041352343/4953389137920000000, 4828262751636749219/ 3095868211200000000), (1218542508044062316794333/ 1141260857376768000000000, 3279336980462019632106743/5135673858195456000000000, 212612808860172995769695813/128391846454886400000000000), (13637450426327/12740198400000, 990212802359779/1528823808000000, 126492506467171/76441190400000), (57118817475004275940253/53496602689536000000000, 152990410470485634830059/240734712102912000000000, 8949213840457409232487219/ 6018367802572800000000000), (29249337645043082844422431/ 27390260577042432000000000, 79018788280174836163958261/123256172596690944000000000, 5112749872172865978006127751/ 3081404314917273600000000000), (188468758362323771/ 176120502681600000, 2582703387969822029/3962711310336000000, 1344826134284667451/792542262067200000), (2118945578460225097951/ 1981355655168000000000, 45566104444819409282887/71328803586048000000000, 1413677412946636018475171/891610044825600000000000), (23400764275915443941517083/21912208461633945600000000, 12611792005038297619839797/19720987615470551040000000, 806119452404553426513633671/ 493024690386763776000000000), (203205027439993027139209/ 190210142896128000000000, 561223437465549111247139/855945643032576000000000, 36796610060033144921369249/21398641075814400000000000), (15702298812493218649/14676708556800000000, 43058856105763601059/66045188505600000000, 2695744765623205425169/ 1651129712640000000000), (101651875265985160659383/ 95105071448064000000000, 278486962424916100438429/427972821516288000000000, 18703610623761334117876639/10699320537907200000000000), (35099995837569335727679913/32868312692450918400000000, 95152842800592204913214371/147907407116029132800000000, 6189366400242610708710954241/3697685177900728320000000000), (58543774867557964812237277/54780521154084864000000000, 157010435048328420534215159/246512345193381888000000000, 9701377359632554281222041669/6162808629834547200000000000), (175564686515039010282171799/164341563462254592000000000, 18751457885266297935698861/29581481423205826560000000, 221251330480337627241254971/ 147907407116029132800000000), (67756580385445686572731/ 63403380965376000000000, 187457219084206354396361/285315214344192000000000, 12221657126985978128488451/7132880358604800000000000), (29418945589955076701/27518828544000000000, 631671745526929430711/990677827584000000000, 18655507910133315244363/ 12383472844800000000000), (135504845370315676496507/ 126806761930752000000000, 372734384842139888953717/570630428688384000000000, 23864899118965952484641947/14265760717209600000000000), (264833806989805889383/247669456896000000000, 2835569942827867212197/4458050224128000000000, 85075732886410423435651/ 55725627801600000000000), (203488646747934050404579/ 190210142896128000000000, 556938135100404855084929/855945643032576000000000, 36930912678290470917455339/21398641075814400000000000), (7316131566075239890429597/6847565144260608000000000, 19748822676991063351359287/30814043149172736000000000, 1274063916638206777194438917/ 770351078729318400000000000), (1464381380084523573809929/ 1369513028852121600000000, 20255312207003746670814511/30814043149172736000000000, 1346058778265136342402056101/770351078729318400000000000), (156879070729200608231/146767085568000000000, 47802208547618785069/73383542784000000000, 997791334350113898893/611529523200000000000), (19162992961329221/ 17915904000000000, 30804413182132403/47775744000000000, 1506002046304971811/895795200000000000), (7316083776446477846564551/6847565144260608000000000, 4039810724408919654486697/6162808629834547200000000, 269001696737713432404828067/154070215745863680000000000), (337041439586266828948789481/315535801847528816640000000, 4553722422856645375981991087/ 7099555541569398374400000000, 293276422031603116112875338437/177488888539234959360000000000), (76198844632125753604699/71328803586048000000000, 3332840747926207629572939/5135673858195456000000000, 103401707894667200597485987/ 64195923227443200000000000), (685729208877421079257741/ 641959232274432000000000, 29695261429919826820239587/46221064723759104000000000, 892857180973677744638048971/577763309046988800000000000), (152240512134371403189761/142657607172096000000000, 806750382197974710304547/1283918464548864000000000, 5949642626678492270866369/ 4012245201715200000000000), (1883192870480999261333/ 1761205026816000000000, 5195513044582109818103/7925422620672000000000, 332226017800885342584173/198135565516800000000000), (33707771447002824127250401091/31553580184752881664000000000, 90208602477096466455154321897/ 141991110831387967488000000000, 5301415536669498332654741214427/3549777770784699187200000000000), (10979062434229792713512299/10271347716390912000000000, 30157026844952634676538201/46221064723759104000000000, 2018026245656335675017232691/ 1155526618093977600000000000), (706452837803923466899/ 660451885056000000000, 3051605150941258426817/4755253572403200000000, 91994279057697698984701/59440669655040000000000), (25267604554850590425787953223/23665185138564661248000000000, 67364828964290595197718078581/ 106493333123540975616000000000, 4037365093393601442717646006271/2662333328088524390400000000000), (18073743418321355442443/16907568257433600000000, 49893480076950057983737/76084057158451200000000, 3229469237137520037949267/ 1902101428961280000000000), (1308621538972831/1223059046400000, 4753383382735867/7338354278400000, 5833737463041053/3669177139200000), (263368535421805592175828587/246512345193381888000000000, 706592336878085412474088129/1109305553370218496000000000, 43952156481113562689606110339/27732638834255462400000000000), (65780253141490466626904797/61628086298345472000000000, 707409883310968453257245159/1109305553370218496000000000, 21150166493727625885948176097/13866319417127731200000000000), (263656065596588429860384531/246512345193381888000000000, 726675653773551879498450833/1109305553370218496000000000, 48455577176308816049207375003/27732638834255462400000000000), (2744369539882853211109741/2567836929097728000000000, 29834736780683982618096839/46221064723759104000000000, 897481174191761634402663337/577763309046988800000000000), (175706415518632427734771357/164341563462254592000000000, 475041956709361715257960247/739537035580145664000000000, 30779553426628225401136726277/ 18488425889503641600000000000), (4238335848918817558687/ 3962711310336000000000, 45553842109567196966621/71328803586048000000000, 1369293742489054847491243/891610044825600000000000), (1883892257896031/1761205026816000, 640926902927688479/990677827584000000, 12543658407283909/7925422620672000), (33695461242051243127778423347/31553580184752881664000000000, 17994521366649133578435139621/ 28398222166277593497600000000, 1061674421044649722156992745231/709955554156939837440000000000), (2743431220702272771611939/2567836929097728000000000, 119668431201804828056808871/184884258895036416000000000, 3686617262824683007880458943/2311053236187955200000000000), (16859475462784826165564679307/15776790092376440832000000000, 45046566546183912541440557249/ 70995555415693983744000000000, 2692586791848327391981972137059/1774888885392349593600000000000), (353366936853496576633/330225942528000000000, 153519030053118690599/237762678620160000000, 941158672619343597893/ 594406696550400000000), (29983862223264254493501823/ 28047626830891450368000000, 10038575094561784980860476201/15776790092376440832000000000, 612416290808726350772609947291/ 394419752309411020800000000000), (2437850030751599349480809/ 2282521714753536000000000, 6691137719906591482922179/10271347716390912000000000, 438304923758113761551388289/256783692909772800000000000), (202256905452375653006214001037/189321481108517289984000000000, 541231293705550612220893009543/ 851946664988327804928000000000, 33097519687994029444676477687413/ 21298666624708195123200000000000), (202114658086881083745771445097/189321481108517289984000000000, 539072548192913844696587142811/ 851946664988327804928000000000, 32075932553595140257664730884401/ 21298666624708195123200000000000), (2437604960855338898799773/2282521714753536000000000, 6689566100151049319216773/10271347716390912000000000, 433586976751242961636332193/ 256783692909772800000000000), (2439695234198792365161941/ 2282521714753536000000000, 6753107973377492099718247/10271347716390912000000000, 446157800941119878703704077/256783692909772800000000000), (7534932997362383339213/7044820107264000000000, 20711078460333867497183/31701690482688000000000, 1315472041133382955604453/ 792542262067200000000000), (314204066745736029817/ 293534171136000000000, 135914129922941506661/211344603217920000000, 848124955521941683307/528361508044800000000), (1130569413760855304807/1056723016089600000000, 12375421996654859612923/19021014289612800000000, 388413452810144343234209/ 237762678620160000000000), (701967955958880419638048711/ 657366253849018368000000000, 1884807973668666588255004781/2958148142320582656000000000, 117802871541760765540307529071/ 73953703558014566400000000000), (613659831680660831/ 573308928000000000, 2984391407975888837/4586471424000000000, 48424954747898842673/ 28665446400000000000), (970655851412940965019729746101/ 908743109320882991923200000000, 12951711507267298298485858238203/ 20446719959719867318272000000000, 777709465329738729718146846664273/ 511167998992996682956800000000000), (19068615770527246619609/ 17832200896512000000000, 822747197220288968252107/1283918464548864000000000, 24604525031996208147832931/16048980806860800000000000)]


 

n2nmax10PrimalPoints2 :: [(Rational, Rational, Rational)] 
n2nmax10PrimalPoints2 =
  [(106833/100000, 521/800, 69/40), (106993/100000, 647701/1000000, 82319/50000), (106993/100000, 320623/500000, 19983/12500), (26729/25000, 647701/1000000, 169413/100000), (26729/25000, 647701/1000000, 19983/12500), (26729/25000, 320623/500000, 19983/12500), (53419/50000, 130831/200000, 43547/25000), (4900963237699/4586471424000, 333898749490361/515978035200000, 169034463695119/103195607040000), (54479209498999/ 50960793600000, 989576300736767/1528823808000000, 48354476733217/30576476160000), (88662461/82944000, 1125855841/1728000000, 236221831/138240000), (245069177077733/229323571200000, 52790753103648107/82556485632000000, 13166216075939951/8255648563200000), (41077717/38400000, 41185699/64000000, 10506177/6400000), (12318289/11520000, 37139933/57600000, 48269987/28800000), (54518767343479/50960793600000, 979894067422079/1528823808000000, 242649273285797/152882380800000), (376274533301584531/ 352241005363200000, 5168779298896983637/7925422620672000000, 108913207672837451/63403380965376000), (147055450609583/ 137594142720000, 159588635710227073/247669456896000000, 41217555246107437/24766945689600000), (7886545549/7372800000, 57641596553/88473600000, 72854925203/44236800000), (36344991559543/33973862400000, 131670914851507/203843174400000, 161492749844261/101921587200000), (146973655421657/137594142720000, 10016511826040731/15479341056000000, 5094090651236093/3095868211200000), (8867845723/8294400000, 3618497761/5529600000, 1192531513/691200000), (490137266367883/458647142400000, 6697165161564061/10319560704000000, 671703848767759/412782428160000), (15870687432123197/14860167413760000, 1714451821494165319/2674830134476800000, 430726101310803391/267483013447680000), (13299391799/ 12441600000, 13491999431/20736000000, 895252279/518400000), (122549618296133/114661785600000, 106193075282886911/165112971264000000, 26079823492803083/16511297126400000), (352778620754047460707/330225942528000000000, 959400949888086199097/1486016741376000000000, 62547105223059532721627/37150418534400000000000), (53253327439/ 49766400000, 430827023597/663552000000, 166931953553/99532800000), (153920833691/144000000000, 25215720011/38400000000, 2510009336159/1440000000000), (735258435698149/687970713600000, 79300857823947977/123834728448000000, 20127307314432233/12383472844800000), (501633003737973809/469654673817600000, 1373101520791353691/2113446032179200000, 3549507669119164273/2113446032179200000), (317345512994743501/ 297203348275200000, 34439388337901340803/53496602689536000000, 69762765596521159/42797282151628800), (423542053475840606663/396271131033600000000, 5819540188835946301313/8916100448256000000000, 388025502326841541819883/ 222902511206400000000000), (392238494590799/366917713920000, 1078789707299269/1651129712640000, 13822061096291339/8255648563200000), (8820522230605727/8255648563200000, 24182754839424277/37150418534400000, 61874626131537247/37150418534400000), (42586164179/39813120000, 1722649947437/2654208000000, 135439138957/79626240000), (653315022689653/611529523200000, 142036934344415813/220150628352000000, 35163572264519201/22015062835200000), (11285254742431673331281/10567230160896000000000, 30788319656514082390651/47552535724032000000000, 2001313141119245839913641/ 1188813393100800000000000), (1663131584083/1555200000000, 6800461798471/10368000000000, 225259797961993/129600000000000), (705642113749709078371/ 660451885056000000000, 1911958286928266646041/2972033482752000000000, 124300987592270023071131/74300837068800000000000), (105786974279136589/99067782758400000, 22992684656648604391/35664401793024000000, 5777698364634276139/3566440179302400000), (2941824344467523/ 2751882854400000, 25294814734366091/39627113103360000, 156601236710195111/99067782758400000), (25387774357563135545339/ 23776267862016000000000, 68743480899437233516369/106993205379072000000000, 4384441720934706993140179/2674830134476800000000000), (2258375763460850323/2113446032179200000, 31072142125287323221/47552535724032000000, 16222165473749505107/9510507144806400000), (5542150264021/ 5184000000000, 2229098135357/3456000000000, 16236274556893/9600000000000), (152396018163099654265339/ 142657607172096000000000, 410124573960824186180369/641959232274432000000000, 25845771237016267255140179/16048980806860800000000000), (5885601800147119/5503765708800000, 127969963964534341/198135565516800000, 31085757362372917/19813556551680000), (11770727398180667/11007531417600000, 161465149589460941/247669456896000000, 83102245526892859/49533891379200000), (7848068180897419/7338354278400000, 108020752746015229/165112971264000000, 55573531665280139/33022594252800000), (11036237163021922043/10319560704000000000, 9513242061491755313/14860167413760000000, 57865828318301925881/ 37150418534400000000), (609363084461698075857373/ 570630428688384000000000, 1642250127379497696142583/2567836929097728000000000, 103648769745618634861981253/64195923227443200000000000), (595329905996719873577/557256278016000000000, 25752559436249091694813/40122452017152000000000, 782286855195382856333429/ 501530650214400000000000), (9029458367932484661613/ 8453784128716800000000, 24637952116880696657519/38042028579225600000000, 1616734310357340089743589/951050714480640000000000), (1884106999656563/1761205026816000, 645787390953903437/990677827584000000, 334769485935618619/198135565516800000), (50851894356549251090659/47552535724032000000000, 139237815632264909776769/213986410758144000000000, 9230840036239395387276779/ 5349660268953600000000000), (44121601840175450069/ 41278242816000000000, 948808863014530183097/1486016741376000000000, 28955624315439391075501/18575209267200000000000), (363095949475014961/339738624000000000, 2977118319135421403/4586471424000000000, 184587231680883604223/ 114661785600000000000), (50852464991528579090659/ 47552535724032000000000, 139788087539748321232769/213986410758144000000000, 9230004332841306171276779/5349660268953600000000000), (2382245660277335715731/2229025112064000000000, 103330938552580438057189/160489808068608000000000, 3122251373349150568969037/ 2006122600857600000000000), (88320962083324359133/ 82556485632000000000, 38206479963213591779/59440669655040000000, 232868853662202662393/148601674137600000000), (2436779889047025530577373/2282521714753536000000000, 6580149196161489283534583/10271347716390912000000000, 413523875460350587645981253/ 256783692909772800000000000), (8473445531040166037731/ 7925422620672000000000, 186676980974050457173/285315214344192000000, 12437376187082300714119/7132880358604800000000), (1240718951567/1159641169920, 126612934933199903/195689447424000000, 31500778288540421/19568944742400000), (1784940463746399617101/1671768834048000000000, 19321290408227969403461/30091839012864000000000, 601962481739115855063163/ 376147987660800000000000), (9807662243677384309/ 9172942848000000000, 210855358030763015377/330225942528000000000, 6331696757782623068741/4127824281600000000000), (7846032369871452947/7338354278400000000, 21482310375946752577/33022594252800000000, 1340862970499564800507/ 825564856320000000000), (9753430112021037585455581/ 9130086859014144000000000, 26255336674509964747085303/41085390865563648000000000, 1614932283284255102647138373/1027134771639091200000000000), (11284805816730546542569/10567230160896000000000, 30787933796769710197679/47552535724032000000000, 1963926108620810907849689/ 1188813393100800000000000), (19616415915933793991/ 18345885696000000000, 54149511030296807341/82556485632000000000, 3517911415477275147631/2063912140800000000000), (30497297942857506411397/28531521434419200000000, 420813905030917952663251/641959232274432000000000, 28013394374136923040437041/ 16048980806860800000000000), (974995316324844773696999/ 913008685901414400000000, 2650508100538094537219821/4108539086556364800000000, 172082985838711177323841231/102713477163909120000000000), (892647861517302759443/835884417024000000000, 308884486927162425597911/481469424205824000000000, 9460888140745273619222263/ 6018367802572800000000000), (14290764840292144895969/ 13374150672384000000000, 308193510910899764196731/481469424205824000000000, 9252509579504808408386623/6018367802572800000000000), (349009128750287/326149079040000, 31562454910671923/48922361856000000, 7905357796993889/4892236185600000), (15691215428910816947/14676708556800000000, 42866605562994101977/66045188505600000000, 2639394652623448450507/ 1651129712640000000000), (176541740614749024413/ 165112971264000000000, 761217068901742540837/1188813393100800000000, 22811764723774605039401/14860167413760000000000), (10716267854217064188367/10030613004288000000000, 1862990849378554272166667/2888816545234944000000000, 56956904735378982900598411/ 36110206815436800000000000), (70639767975139164413/ 66045188505600000000, 972984964126815057467/1486016741376000000000, 63530041395968951535497/37150418534400000000000), (6816783895607/6370099200000, 164495361781121/254803968000000, 2324832602617/1415577600000), (857076811375443278603/802449040343040000000, 1868843052146773693201097/2888816545234944000000000, 58577010018617208448985401/ 36110206815436800000000000), (28564320746488098856703/ 26748301344768000000000, 307776105338695378892209/481469424205824000000000, 9307885413645262627744847/6018367802572800000000000), (529268528093947098151/495338913792000000000, 23210388874164830524331/35664401793024000000000, 734810433867820357859923/ 445805022412800000000000), (529793233989901897951/ 495338913792000000000, 11396758676495862146887/17832200896512000000000, 347532439067749618475171/222902511206400000000000), (353331487933501962977/330225942528000000000, 152701355421922472341/237762678620160000000, 937960549600875522667/594406696550400000000), (3195059956474733/ 2985984000000000, 5170754719700747/7962624000000000, 253850813093146939/149299200000000000), (27089137366892470539707/25361352386150400000000, 74220286423909547790637/114126085737676800000000, 4760160692373552842949067/ 2853152143441920000000000), (3660836797577436010635053/ 3423782572130304000000000, 10098040243957323897054511/15407021574586368000000000, 672608553048176358019284901/385175539364659200000000000), (33880021845073950080893/31701690482688000000000, 92274879152613152580959/142657607172096000000000, 6064596326784435664794869/ 3566440179302400000000000), (5647658928452198822107/ 5283615080448000000000, 15593176700525214314537/23776267862016000000000, 1021817931606524492236067/594406696550400000000000), (8573134002427474757927/8024490403430400000000, 7490725729661699853396437/11555266180939776000000000, 233206991885844191567377621/ 144440827261747200000000000), (85698580990114982751707/ 80244904034304000000000, 7444652911762459064580563/11555266180939776000000000, 230253309821635428084318979/144440827261747200000000000), (514287504280860596574101/481469424205824000000000, 11114689414602796473704603/17332899271409664000000000, 334655820443531174572192399/ 216661240892620800000000000), (33865633611855205870963/ 31701690482688000000000, 93152875819101906857393/142657607172096000000000, 6093337348087302588679163/3566440179302400000000000), (38094467538092636035963/35664401793024000000000, 1653088012883201148071723/2567836929097728000000000, 50318432852645770281801859/ 32097961613721600000000000), (228559452662926546924319/ 213986410758144000000000, 123038016005884948911557/192587769682329600000000, 7336213704297151322499197/4814694242058240000000000), (609747387709612729465339/570630428688384000000000, 1639209428401728258620369/2567836929097728000000000, 102750537978088687597140179/ 64195923227443200000000000), (342690592628163808760471/ 320979616137216000000000, 369312776896946214310549/577763309046988800000000, 351452024766601508698261/225688792596480000000000), (56513017257904813/52836150804480000, 15448709655944266871/23776267862016000000, 3927658313806967861/2377626786201600000), (3768988189696153/ 3522410053632000, 2060781478297474957/3170169048268800000, 2636920946221754261/1585084524134400000), (6776029414659147962303/6340338096537600000000, 18676580234438279573749/28531521434419200000000, 1210234293735548719750759/ 713288035860480000000000), (1028059933807467786125483/ 962938848411648000000000, 89026517585968699227636593/138663194171277312000000000, 2753299237328594025182628769/ 1733289927140966400000000000), (526621087256361505055722517/ 493024690386763776000000000, 1415158370795499346680907039/2218611106740436992000000000, 88114794672649480007174316349/ 55465277668510924800000000000), (76152485528424544120241/ 71328803586048000000000, 408937161987989413418111/641959232274432000000000, 769604392568629339128793/501530650214400000000000), (313883194989398139019/293534171136000000000, 95763987021276547681/146767085568000000000, 2015647207179232662857/ 1223059046400000000000), (117760194898269971503/ 110075314176000000000, 50766107300954368739/79254226206720000000, 307804150778182254413/198135565516800000000), (1219452357582133445625463/1141260857376768000000000, 3352954843819427307109853/5135673858195456000000000, 223945225598608889574025823/ 128391846454886400000000000), (4112882633346149822630171/ 3851755393646592000000000, 71568273147367076503259821/110930555337021849600000000, 2240291950707530747903437853/ 1386631941712773120000000000), (2740983763102919790763111/ 2567836929097728000000000, 14780619197193450846460489/23110532361879552000000000, 28475070439396977433124357/18055103407718400000000000), (6278255462255910949/5870683422720000000, 17170544169001228459/26418075402240000000, 1063806984593912917669/ 660451885056000000000), (351070104961802912137778117/ 328683126924509184000000000, 37637268132620688224813959/59162962846411653120000000, 2253367337968152010842601333/1479074071160291328000000000), (204391791389/191102976000, 41221047505903/63700992000000, 3239079011279/1911029760000), (4112574682028016821013091/3851755393646592000000000, 4416437008960135423667849/6933159708563865600000000, 8214425045942562394005847/ 5416531022315520000000000), (28102869670066014020436271/ 26294650153960734720000000, 1885920155285267602287295973/2958148142320582656000000000, 112292167621432915370969870543/ 73953703558014566400000000000), (762603027441633798247/ 713288035860480000000, 206073941025779037078683/320979616137216000000000, 6172799284519328969437489/4012245201715200000000000), (180601397370612258877793/169075682574336000000000, 494241483310205341333483/760840571584512000000000, 32758845609986216780384953/ 19021014289612800000000000), (2271674798233/2123366400000, 163574049797389/254803968000000, 20605017124621/12740198400000), (1404785852928253924505766433/1314732507698036736000000000, 752988647175065784738430759/ 1183259256928233062400000000, 45499193500871769849900708949/29581481423205826560000000000), (421177050482360073573784711/394419752309411020800000000, 1139313585521470670595696557/ 1774888885392349593600000000, 73107437689889234846243020847/44372222134808739840000000000), (1404204811848562380154790131/1314732507698036736000000000, 3763409642434692250441932281/ 5916296284641165312000000000, 222973107154060651562574082571/147907407116029132800000000000), (8474902498354896364819/7925422620672000000000, 182052924757907697065587/285315214344192000000000, 5574430025791957266346271/ 3566440179302400000000000), (32894818421636942261969629/ 30814043149172736000000000, 354806526341363374355329511/554652776685109248000000000, 10844415846182960328406886113/ 6933159708563865600000000000), (29276341871202218039649949/ 27390260577042432000000000, 79238447174612256597370679/123256172596690944000000000, 5127263657703998210706096389/ 3081404314917273600000000000), (22882683952602862755647/ 21398641075814400000000, 1238549320485620573567873/1925877696823296000000000, 37441658447053302462547759/24073471210291200000000000), (135421942928646729618463/126806761930752000000000, 370510220508014620431893/570630428688384000000000, 24104572940104537526366663/ 14265760717209600000000000), (37468562654556585136668539/ 35059533538614312960000000, 2509132699318911650365364521/3944197523094110208000000000, 152644060316924126181604000411/ 98604938077352755200000000000), (101530296841008515785339/ 95105071448064000000000, 275187609983804637170369/427972821516288000000000, 17500284888026352662640179/10699320537907200000000000), (76252643271024409722023/71328803586048000000000, 827966976517322353449061/1283918464548864000000000, 24912956586231592467375563/ 16048980806860800000000000), (1219277097348168158588947/ 1141260857376768000000000, 3319938360041712999695201/5135673858195456000000000, 218537720098285648086143291/128391846454886400000000000), (5620294846917464127879901703/5258930030792146944000000000, 15050171336905757604182005429/ 23665185138564661248000000000, 899140324060535944398990626239/591629628464116531200000000000), (1873117506264800493996782603/1752976676930715648000000000, 5032519279467218531957510977/ 7888395046188220416000000000, 298591809404116356826046094307/197209876154705510400000000000), (406206774132335874813913/380420285792256000000000, 1107935568444795172846613/1711891286065152000000000, 71270663475341205373654133/42797282151628800000000000), (33711714285583360255236258113/31553580184752881664000000000, 90929449174178679770524866283/ 141991110831387967488000000000, 5805667130942744105767129662553/3549777770784699187200000000000), (3530761505434597/3302259425280000, 761589125600273377/1188813393100800000, 190993114575212797/118881339310080000), (175701919862933855205729949/164341563462254592000000000, 475267221353190362300794679/739537035580145664000000000, 30498689056782985114002096389/18488425889503641600000000000), (6746387015436904837280617477/6310716036950576332800000000, 90372138541803254940985175467/ 141991110831387967488000000000, 5446959972394169411176803360097/3549777770784699187200000000000), (4936919209175633763193549/4622106472375910400000000, 2153842973841705238692408989/3327916660110655488000000000, 67002557906422831303355157037/ 41598958251383193600000000000), (457340544479172507197251/ 427972821516288000000000, 4946348031987346617153401/7703510787293184000000000, 147953842214128323647896183/96293884841164800000000000), (163602399232303/152882380800000, 791362086150773/1223059046400000, 56467437325697/33973862400000), (16472799954945838657292629/15407021574586368000000000, 45336853002856726484358887/69331597085638656000000000, 3027095139380974378764152717/1733289927140966400000000000), (16846935895996906859245804157/15776790092376440832000000000, 45131668290228111595419201367/ 70995555415693983744000000000, 2747369987716943255437497005797/1774888885392349593600000000000), (16845747351431623446499065683/15776790092376440832000000000, 45056677871354168224638975001/ 70995555415693983744000000000, 2694282853190797489564637360491/1774888885392349593600000000000), (101048952031232284099840934983/94660740554258644992000000000, 270226793853850418882811955829/ 425973332494163902464000000000, 16269462615504682132315062896639/ 10649333312354097561600000000000), (101100428435387598116391750349/94660740554258644992000000000, 270205033637053658781737765447/ 425973332494163902464000000000, 16299644870261086603135703562677/ 10649333312354097561600000000000), (471087970048398994187/440301256704000000000, 1289465062901713455001/1981355655168000000000, 84454441659590980630291/ 49533891379200000000000), (1184430296959136695640250253/ 1109305553370218496000000000, 3201748506731159554126942643/4991874990165983232000000000, 194439849277815692925193908563/ 124796874754149580800000000000), (606260866141515076112080263751/567964443325551869952000000000, 1630090764700922834542011176693/2555839994964983414784000000000, 98451748903637042055487778436863/ 63895999874124585369600000000000), (1830116311518562152623341/ 1711891286065152000000000, 19804676572558915606032503/30814043149172736000000000, 592332011714554791552316249/385175539364659200000000000), (1255154913797411860697/1174136684544000000000, 1149405125510911340209/1761205026816000000000, 72719467870513692167419/ 44030125670400000000000), (406717426808118773240701/ 380420285792256000000000, 1113178981316963921143967/1711891286065152000000000, 74138268187092964316430197/42797282151628800000000000), (157048374012132189817/146767085568000000000, 67796240621993333861/105672301608960000000, 419702959163494579307/ 264180754022400000000), (2260963745351909257/2113446032179200000, 123459037146281995483/190210142896128000000, 31015150887954809257/19021014289612800000), (242487026984127865636965944027/227185777330220747980800000000, 653119309540206876476132282161/ 1022335997985993365913600000000, 39890085558875047675717744184371/ 25558399949649834147840000000000), (404490730873758263727990880111/378642962217034579968000000000, 1081493757016860779523105212141/ 1703893329976655609856000000000, 64609506249306054594464623894631/ 42597333249416390246400000000000), (8422356902358905067620382113/7888395046188220416000000000, 22730405979489220676280246283/ 35497777707846991872000000000, 1444310556791807188267757466553/887444442696174796800000000000), (7106334579067335927255507691/6655833320221310976000000000, 38283915715414753866628470787/ 59902499881991798784000000000, 574205378199658855339278335623/374390624262448742400000000000), (161830363632032699277127103593/151457184886813831987200000000, 434613479955637061324777754011/ 681557331990662243942400000000, 26816021435695440079978458199601/ 17038933299766556098560000000000), (4737992951229014345218338349/4437222213480873984000000000, 402028106950980769082622103/ 623984373770747904000000000, 797248855753404126167552074061/499187499016598323200000000000), (809101706211174322963783764019/757285924434069159936000000000, 2164172822586749796760573963961/ 3407786659953311219712000000000, 130978967959151742609958014546251/85194666498832780492800000000000), (40673143016803834409753/38042028579225600000000, 554440981401988067026271/855945643032576000000000, 36634210593809209713571061/21398641075814400000000000), (969883257006550669114009654559/908743109320882991923200000000, 12993602212205889968153352194417/ 20446719959719867318272000000000, 790281300578089722058532078050547/ 511167998992996682956800000000000), (130878861270347/122305904640000, 630985760703337/978447237120000, 672388534786091/407686348800000), (40694207193675111495431/38042028579225600000000, 559287794453217492504641/855945643032576000000000, 36744684365664681392946731/ 21398641075814400000000000), (609198124611968589283121/ 570630428688384000000000, 1652350366950534744847111/2567836929097728000000000, 103933126296926390609647201/64195923227443200000000000), (2327021038425689/2174327193600000, 126231148834627571/195689447424000000, 6368475804969517/3913788948480000), (162746470925904072329443/152168114316902400000000, 444656078343949368956801/684756514426060800000000, 29423035946974055882112491/ 17118912860651520000000000), (1506432841875495575689/ 1408964021452800000000, 4130661497196919876099/6340338096537600000000, 258275972764661987037409/158508452413440000000000), (43899926504852309201495431/41085390865563648000000000, 24210254566729526877825001/36976851779007283200000000, 1593040843769217077935866211/924421294475182080000000000)]




n2nmax10TestPoints :: [(Rational, Rational, Rational)] 
n2nmax10TestPoints =
  [(1.06833, 0.65125, 1.725), (1.06916, 0.641246, 1.59864), (1.06916, 0.647701, 1.69413), (1.06838, 0.654155, 1.74188), (1.06916, 0.647701, 1.59864), (1.06993, 0.647701, 1.64638), (1.06993, 0.641246, 1.59864)] 

-- nmax = 12
n2nmax12DualPoints :: [(Rational, Rational, Rational)] 
n2nmax12DualPoints =  
  [(7886545549/7372800000,57641596553/88473600000,72854925203/44236800000 ), (41077717/38400000 ,41185699/64000000,10506177/6400000 ), (36344991559543/33973862400000,131670914851507/203843174400000,161492749844261/101921587200000 ), (2218732529/2073600000,143287247167/221184000000,167160825419/99532800000 ), (153920833691/144000000000,25215720011/38400000000,2510009336159/1440000000000 ), (2941824344467523/2751882854400000,25294814734366091/39627113103360000,156601236710195111/99067782758400000 ), (54479209498999/50960793600000,989576300736767/1528823808000000,48354476733217/30576476160000 ), (735258435698149/687970713600000,79300857823947977/123834728448000000,20127307314432233/12383472844800000 ), (106993/100000 ,320623/500000,19983/12500 ), (54518767343479/50960793600000,979894067422079/1528823808000000,242649273285797/152882380800000 ), (12318289/11520000 ,37139933/57600000,48269987/28800000 ), (53419/50000 ,130831/200000,43547/25000 ), (106993/100000 ,647701/1000000,82319/50000 ), (5543922500297/5184000000000,1125396190331/1728000000000,1384046736249/800000000000 ), (392238494590799/366917713920000,1078789707299269/1651129712640000,13822061096291339/8255648563200000 ), (26729/25000 ,647701/1000000,19983/12500 ), (1838373710072533819/1719926784000000000,80005333093021997309/123834728448000000000,2634308633624773307797/1547934105600000000000 ), (245069177077733/229323571200000,52790753103648107/82556485632000000,13166216075939951/8255648563200000 )]
n2nmax12PrimalPoints :: [(Rational, Rational, Rational)]    
n2nmax12PrimalPoints = 
  [(15870687432123197/14860167413760000,1714451821494165319/2674830134476800000,430726101310803391/267483013447680000 ), (88662461/82944000,1125855841/1728000000,236221831/138240000 ), (2258375763460850323/2113446032179200000,31072142125287323221/47552535724032000000,16222165473749505107/9510507144806400000 ), (122549618296133/114661785600000,106193075282886911/165112971264000000,26079823492803083/16511297126400000 ), (653315022689653/611529523200000,142036934344415813/220150628352000000,35163572264519201/22015062835200000 ), (317465108622926893/297203348275200000,34333290489911742173/53496602689536000000,8734708007600899373/5349660268953600000 ), (147055450609583/137594142720000,159588635710227073/247669456896000000,41217555246107437/24766945689600000 ), (13299391799/12441600000,13491999431/20736000000,895252279/518400000 ), (376274533301584531/352241005363200000,5168779298896983637/7925422620672000000,108913207672837451/63403380965376000 ), (1505040429989762707/1408964021452800000,20596753549109396053/31701690482688000000,10636717956281641043/6340338096537600000 ), (317375343517772521/297203348275200000,34439777706992306339/53496602689536000000,8710385187719894939/5349660268953600000 ), (4900963237699/4586471424000,333898749490361/515978035200000,169034463695119/103195607040000 ), (26729/25000 ,320623/500000,19983/12500 ), (490137266367883/458647142400000,6697165161564061/10319560704000000,671703848767759/412782428160000 ), (41804174190832187/39137889484800000,114043769405992177/176120502681600000,59528095469419151/35224100536320000 ), (13307840753/12441600000,1349935817/2073600000,7060523591/4147200000 ), (8867845723/8294400000,3618497761/5529600000,1192531513/691200000 ), (106833/100000 ,521/800,69/40 ), (26729/25000 ,647701/1000000,169413/100000 ), (361289798504490379/338151365148672000,24779728421446055441/38042028579225600000,63563637461244263507/38042028579225600000 ), (401256886626342401/375723739054080000,27436771139750690899/42268920643584000000,14299830034005436997/8453784128716800000 )]   

epsN2nmax6DualPoints :: [(Rational, Rational, Rational)]
epsN2nmax6DualPoints =
  [(134/125, 69/100, 8/5), (133/125, 63/100, 8/5), (267/250, 71/100,13/10), (134/125, 13/20, 8/5), (134/125, 63/100, 13/10), (53/50, 13/20, 8/5), (133/125, 13/20, 7/5), (134/125, 67/100, 13/10), (267/250, 71/100, 8/5), (134/125, 67/100, 7/5)]
epsN2nmax6PrimalPoints :: [(Rational, Rational, Rational)]
epsN2nmax6PrimalPoints =
  [(267/250, 13/20, 8/5),(267/250, 13/20, 17/10),(134/125, 13/20, 17/10)]
